
/*  A Bison parser, made from scan-fct.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse fctparse
#define yylex fctlex
#define yyerror fcterror
#define yylval fctlval
#define yychar fctchar
#define yydebug fctdebug
#define yynerrs fctnerrs
#define	VARNAME	257
#define	COMMENT	258
#define	CONSTNAME	259
#define	PREDNAME	260
#define	TYPENAME	261
#define	QUANT	262
#define	IMPL	263
#define	NOT	264
#define	INI	265
#define	GOA	266

#line 1 "scan-fct.y"

#include <stdio.h>
#include <string.h> 
#include "ipp.h"

int act_err;
char *act_err_par;
fact_list act_var, act_const;
effect_list q_goal_list;
token_list act_goal;
fact_list act_pardec;
fact_list new_neg_pred;

#ifndef SCAN_ERR
#define SCAN_ERR
#define TYPELIST_EXPECTED            0
#define INITIALTOK_EXPECTED          1
#define FACTLIST_EXPECTED            2
#define SEMICOLON_EXPECTED           3
#define GOALTOK_EXPECTED             4
#define	GOALS_EXPECTED               5
#define TYPENAME_EXPECTED            6
#define CONSTLIST_EXPECTED           7
#define PARDEC_EXPECTED              8
#define GOALCOND_OR_IMPL_EXPECTED    9
#define MISSING_GOALDES             10
#define TYPENAME_UNKNOWN            11
#endif

static char *errmsg[] = {
  "typelist expected",
  "\'initial:\' or typelist expected",
  "list of facts expected",
  "\';\' expected",
  "\'goal:\' expected",
  "list of goals expected",
  "typename ( \'type\' : ) expexted",
  "list of constants expected",
  "parameter declaration for quantifier expected",
  "goal conditions or \'=>' expected",
  "missing goal description",
  "unknown type '%s' (check for typing errors...)",
  NULL
};

void fcterr( int errno, char *par );
BOOLEAN cond_in_initial( token_list conds, token_list initials );
effect_list make_q_goal_list( fact_list pars, fact_list conds, 
			      fact_list goals, int quant );


#line 57 "scan-fct.y"
typedef union {
  char string[256];
  fact_list fact_list;
  op_list op_list;
  token_list token_list;
  effect_list effect_list;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		63
#define	YYFLAG		-32768
#define	YYNTBASE	17

#define YYTRANSLATE(x) ((unsigned)(x) <= 266 ? yytranslate[x] : 38)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    15,
    16,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    14,    13,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     2,     3,     4,     5,     6,    19,    20,    21,
    22,    23,    34,    40,    44,    45,    46,    47,    48,    57,
    59,    62,    65,    66,    71,    73,    76,    77,    83,    90,
    91,    94
};

static const short yyrhs[] = {    -1,
     0,     0,     0,     0,     0,    18,    28,    19,    11,    20,
    36,    21,    13,    22,    12,    23,    24,     0,     0,     0,
     0,     0,     8,    25,    33,    26,    36,     9,    27,    36,
    13,    24,     0,    36,     9,    36,    13,    24,     0,    36,
    13,    24,     0,     0,     0,     0,     0,    29,     7,    14,
    30,    32,    13,    31,    28,     0,     5,     0,     5,    32,
     0,    35,     5,     0,     0,    35,     5,    34,    33,     0,
     3,     0,     3,    35,     0,     0,     6,    15,    37,    16,
    36,     0,    10,     6,    15,    37,    16,    36,     0,     0,
     5,    37,     0,     3,    37,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    98,    99,   103,   104,   105,   107,   108,   114,   116,   117,
   117,   118,   131,   136,   143,   145,   145,   146,   148,   166,
   175,   187,   206,   215,   234,   243,   254,   256,   266,   279,
   281,   288
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","VARNAME",
"COMMENT","CONSTNAME","PREDNAME","TYPENAME","QUANT","IMPL","NOT","INI","GOA",
"';'","':'","'('","')'","factfile","@1","@2","@3","@4","@5","@6","goals","@7",
"@8","@9","typelist","@10","@11","@12","constantlist","pardec","@13","varlist",
"factlist","args", NULL
};
#endif

static const short yyr1[] = {     0,
    18,    19,    20,    21,    22,    23,    17,    24,    25,    26,
    27,    24,    24,    24,    28,    29,    30,    31,    28,    32,
    32,    33,    34,    33,    35,    35,    36,    36,    36,    37,
    37,    37
};

static const short yyr2[] = {     0,
     0,     0,     0,     0,     0,     0,    12,     0,     0,     0,
     0,    10,     5,     3,     0,     0,     0,     0,     8,     1,
     2,     2,     0,     4,     1,     2,     0,     5,     6,     0,
     2,     2
};

static const short yydefact[] = {     1,
    15,     2,     0,     0,     0,     3,    17,    27,     0,     0,
     0,     4,    20,     0,    30,     0,     0,    21,    18,    30,
    30,     0,    30,     5,    15,    32,    31,    27,     0,     0,
    19,    28,    27,     6,    29,    27,     9,     7,     0,     0,
    27,    27,    25,    10,     0,     0,    14,    26,    27,    22,
    27,     0,     0,    13,    11,    24,    27,     0,    27,    12,
     0,     0,     0
};

static const short yydefgoto[] = {    61,
     1,     4,     8,    17,    30,    36,    38,    40,    49,    57,
     2,     3,     9,    25,    14,    44,    53,    45,    39,    22
};

static const short yypact[] = {-32768,
     5,-32768,     9,     8,     7,-32768,-32768,    -4,    17,    11,
    18,-32768,    17,    10,     2,    12,    15,-32768,-32768,     2,
     2,    13,     2,-32768,     5,-32768,-32768,    -4,    14,    19,
-32768,-32768,    -4,-32768,-32768,     3,-32768,-32768,    -5,    29,
    -4,     3,    29,-32768,    30,    21,-32768,-32768,    -4,    33,
     3,    28,    29,-32768,-32768,-32768,    -4,    25,     3,-32768,
    39,    40,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   -41,-32768,-32768,-32768,
    20,-32768,-32768,-32768,    31,   -11,-32768,     0,    -8,    -6
};


#define	YYLAST		49


static const short yytable[] = {    12,
    47,    10,    -8,    41,    20,    11,    21,    42,    10,    54,
    37,   -16,    11,    26,    27,     5,    29,    60,     6,    32,
     7,    13,    19,    16,    35,    15,    23,    24,    28,    33,
    34,    43,    46,    51,    50,   -23,    55,    59,    62,    63,
    52,    56,    48,    18,    31,     0,     0,     0,    58
};

static const short yycheck[] = {     8,
    42,     6,     0,     9,     3,    10,     5,    13,     6,    51,
     8,     7,    10,    20,    21,     7,    23,    59,    11,    28,
    14,     5,    13,     6,    33,    15,    15,    13,    16,    16,
    12,     3,    41,    13,     5,     3,     9,    13,     0,     0,
    49,    53,    43,    13,    25,    -1,    -1,    -1,    57
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 98 "scan-fct.y"
{ fcterr( TYPELIST_EXPECTED, NULL ); ;
    break;}
case 2:
#line 99 "scan-fct.y"
{ orig_constant_list = yyvsp[0].fact_list;
		    /* build a fact list containing token_lists for all types */
		    build_type_list();		    
		    fcterr( INITIALTOK_EXPECTED, NULL ); ;
    break;}
case 3:
#line 103 "scan-fct.y"
{ fcterr( FACTLIST_EXPECTED, NULL ); ;
    break;}
case 4:
#line 104 "scan-fct.y"
{ fcterr( SEMICOLON_EXPECTED, NULL ); ;
    break;}
case 5:
#line 105 "scan-fct.y"
{ orig_initial_facts = yyvsp[-2].fact_list;
		    fcterr( GOALTOK_EXPECTED, NULL ); ;
    break;}
case 6:
#line 107 "scan-fct.y"
{ fcterr( GOALS_EXPECTED, NULL ); ;
    break;}
case 7:
#line 108 "scan-fct.y"
{
		    raw_goal_facts = yyvsp[0].effect_list;
		  ;
    break;}
case 8:
#line 115 "scan-fct.y"
{ yyval.effect_list = NULL; ;
    break;}
case 9:
#line 116 "scan-fct.y"
{ fcterr( PARDEC_EXPECTED, NULL ); ;
    break;}
case 10:
#line 117 "scan-fct.y"
{ fcterr( GOALCOND_OR_IMPL_EXPECTED, NULL ); ;
    break;}
case 11:
#line 118 "scan-fct.y"
{ fcterr( MISSING_GOALDES, NULL ); ;
    break;}
case 12:
#line 119 "scan-fct.y"
{
		      if ( !yyvsp[-2].fact_list ) 
			{
			  fcterr( MISSING_GOALDES, NULL );
			  yyerror();
			}
		      if ( yyvsp[-9].string[0] == 'A' )
			yyval.effect_list = make_q_goal_list( yyvsp[-7].fact_list, yyvsp[-5].fact_list, yyvsp[-2].fact_list, ALL_QUANT );
		      else
			yyval.effect_list = make_q_goal_list( yyvsp[-7].fact_list, yyvsp[-5].fact_list, yyvsp[-2].fact_list, EX_QUANT );
		      yyval.effect_list->next = yyvsp[0].effect_list;
		    ;
    break;}
case 13:
#line 132 "scan-fct.y"
{
		      yyval.effect_list = make_q_goal_list( NULL, yyvsp[-4].fact_list, yyvsp[-2].fact_list, NO_QUANT );
		      yyval.effect_list->next = yyvsp[0].effect_list;
		    ;
    break;}
case 14:
#line 137 "scan-fct.y"
{ 
		      yyval.effect_list = make_q_goal_list( NULL, NULL, yyvsp[-2].fact_list, NO_QUANT );
		      yyval.effect_list->next = yyvsp[0].effect_list;
		    ;
    break;}
case 15:
#line 144 "scan-fct.y"
{ yyval.fact_list = NULL; ;
    break;}
case 16:
#line 145 "scan-fct.y"
{ fcterr( TYPENAME_EXPECTED, NULL ); ;
    break;}
case 17:
#line 146 "scan-fct.y"
{ fcterr( CONSTLIST_EXPECTED, NULL ); ;
    break;}
case 18:
#line 147 "scan-fct.y"
{ fcterr( TYPELIST_EXPECTED, NULL ); ;
    break;}
case 19:
#line 148 "scan-fct.y"
{
		      yyval.fact_list = yyvsp[-3].fact_list;
		      for( act_const=yyval.fact_list; act_const; act_const=act_const->next )
			{ /* adjust types of constant list */
			  act_const->item->next = 
			    ( token_list ) malloc( sizeof( token_list_elt ) );
			  act_const->item->next->item = 
			    ( token ) calloc( 1 + strlen( yyvsp[-6].string ), sizeof( char ) );
			  strcpy( act_const->item->next->item, yyvsp[-6].string );
			  act_const->item->next->next = NULL;
			  if ( !act_const->next ) {
			    act_const->next = yyvsp[0].fact_list; 
			    break;
			  }
			}
		    ;
    break;}
case 20:
#line 167 "scan-fct.y"
{
		      yyval.fact_list = ( fact_list ) malloc( sizeof( fact_list_elt ) );
		      yyval.fact_list->item = ( token_list ) malloc( sizeof( token_list_elt ) );
		      yyval.fact_list->item->item = 
			( token ) calloc( 1 + strlen( yyvsp[0].string ), sizeof( char ) );
		      strcpy( yyval.fact_list->item->item, yyvsp[0].string );
		      yyval.fact_list->next = NULL;
		    ;
    break;}
case 21:
#line 176 "scan-fct.y"
{
		      yyval.fact_list = ( fact_list ) malloc( sizeof( fact_list_elt ) );
		      yyval.fact_list->item = ( token_list ) malloc( sizeof( token_list_elt ) );
		      yyval.fact_list->item->item = 
			( token ) calloc( 1 + strlen( yyvsp[-1].string ), sizeof( char ) );
		      strcpy( yyval.fact_list->item->item, yyvsp[-1].string );
		      yyval.fact_list->next = yyvsp[0].fact_list;
		    ;
    break;}
case 22:
#line 188 "scan-fct.y"
{
		      yyval.fact_list = yyvsp[-1].fact_list;
		      act_pardec = yyval.fact_list;
		      if ( !type_known( yyvsp[0].string ) )
			{
			  fcterr( TYPENAME_UNKNOWN, yyvsp[0].string );
			  yyerror();
			}
		      for( act_var=yyval.fact_list; act_var; act_var=act_var->next )
			{ /* adjust types (2nd element of token_list) for varlist */
			  act_var->item->next = 
			    ( token_list ) malloc( sizeof( token_list_elt ) );
			  act_var->item->next->item = 
			    ( token ) calloc( 1 + strlen( yyvsp[0].string ), sizeof( char ) );
			  strcpy( act_var->item->next->item, yyvsp[0].string );
			  act_var->item->next->next = NULL;
			}
		    ;
    break;}
case 23:
#line 207 "scan-fct.y"
{
		    if ( !type_known( yyvsp[0].string ) )
		      {
			fcterr( TYPENAME_UNKNOWN, yyvsp[0].string );
			yyerror();
		      }
		  ;
    break;}
case 24:
#line 215 "scan-fct.y"
{
		      yyval.fact_list = yyvsp[-3].fact_list;
		      act_pardec = yyval.fact_list;
		      for( act_var=yyval.fact_list; act_var; act_var=act_var->next )
			{ /* adjust types (2nd element of token_list) for varlist */
			  act_var->item->next = 
			    ( token_list ) malloc( sizeof( token_list_elt ) );
			  act_var->item->next->item = 
			    ( token ) calloc( 1 + strlen( yyvsp[-2].string ), sizeof( char ) );
			  strcpy( act_var->item->next->item, yyvsp[-2].string );
			  act_var->item->next->next = NULL;
			  if ( !act_var->next ) {
			    act_var->next = yyvsp[0].fact_list; 
			    break;
			  }
			}
		    ;
    break;}
case 25:
#line 235 "scan-fct.y"
{
		      yyval.fact_list = ( fact_list ) malloc( sizeof( fact_list_elt ) );
		      yyval.fact_list->item = ( token_list ) malloc( sizeof( token_list_elt ) );
		      yyval.fact_list->item->item = 
			( token ) calloc( 1 + strlen( yyvsp[0].string ), sizeof( char ) );
		      strcpy( yyval.fact_list->item->item, yyvsp[0].string );
		      yyval.fact_list->next = NULL;
		    ;
    break;}
case 26:
#line 244 "scan-fct.y"
{
		      yyval.fact_list = ( fact_list ) malloc( sizeof( fact_list_elt ) );
		      yyval.fact_list->item = ( token_list ) malloc( sizeof( token_list_elt ) );
		      yyval.fact_list->item->item = 
			( token ) calloc( 1 + strlen( yyvsp[-1].string ), sizeof( char ) );
		      strcpy( yyval.fact_list->item->item, yyvsp[-1].string );
		      yyval.fact_list->next = yyvsp[0].fact_list;
		    ;
    break;}
case 27:
#line 255 "scan-fct.y"
{ yyval.fact_list = NULL; ;
    break;}
case 28:
#line 257 "scan-fct.y"
{
		      yyval.fact_list = ( fact_list ) malloc( sizeof( fact_list_elt ) );
		      yyval.fact_list->item = ( token_list ) malloc( sizeof( token_list_elt ) );
		      yyval.fact_list->item->item = 
			( token ) calloc( 1 + strlen( yyvsp[-4].string ), sizeof( char ) );
		      strcpy( yyval.fact_list->item->item, yyvsp[-4].string );
		      yyval.fact_list->item->next = yyvsp[-2].token_list;
		      yyval.fact_list->next = yyvsp[0].fact_list;
             	    ;
    break;}
case 29:
#line 267 "scan-fct.y"
{
		      yyval.fact_list = ( fact_list ) malloc( sizeof( fact_list_elt ) );
		      yyval.fact_list->item = ( token_list ) malloc( sizeof( token_list_elt ) );
		      yyval.fact_list->item->item = 
			( token ) calloc( 2 + strlen( yyvsp[-4].string ), sizeof( char ) );
		      strcpy( yyval.fact_list->item->item, "!" );
		      strcat( yyval.fact_list->item->item, yyvsp[-4].string );
		      yyval.fact_list->item->next = yyvsp[-2].token_list;
		      yyval.fact_list->next = yyvsp[0].fact_list;
                    		             	    ;
    break;}
case 30:
#line 280 "scan-fct.y"
{ yyval.token_list = NULL; ;
    break;}
case 31:
#line 282 "scan-fct.y"
{
		      yyval.token_list = ( token_list ) malloc( sizeof( token_list_elt ) );
		      yyval.token_list->item = ( token ) calloc( 1 + strlen( yyvsp[-1].string ), sizeof( char ) );
		      strcpy( yyval.token_list->item, yyvsp[-1].string );
		      yyval.token_list->next = yyvsp[0].token_list;
		    ;
    break;}
case 32:
#line 289 "scan-fct.y"
{
		      token_list t;
		      t = ( token_list ) malloc( sizeof( token_list_elt ) );
		      t->item = ( token ) calloc( 1 + strlen( yyvsp[-1].string ), sizeof( char ) );
		      strcpy( t->item, yyvsp[-1].string );
		      t->next = yyvsp[0].token_list;
		      yyval.token_list = t;
		    ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 300 "scan-fct.y"


/* lexer must be built with:  flex -Pfct lex-fct.l */
#include "lex.fct.c"

void fcterr( int errno, char *par )
{
  act_err = errno;
  act_err_par = par;
}
  
int yyerror( char *msg )
{
  printf("%s: syntax error in line %d, '%s':\n", act_filename, lineno, yytext );
  if ( act_err_par )
    {
      printf( errmsg[act_err], act_err_par );
      printf( "\n" );
    }
  else
    printf("%s\n", errmsg[act_err] );
  exit( 1 );
}

  
void load_fct_file( char *filename )
{
  FILE *fp;/* pointer to input files */

  /* open fact file */
  if( ( fp = fopen( filename, "r" ) ) == NULL ) {
    printf( "\nipp: can't find fact file: %s\n\n", filename );
    exit( 1 );
  }
  act_filename = filename;
  lineno = 1; 
  yyin = fp;
  yyparse();
  fclose( fp );/* and close file again */
}


effect_list make_q_goal_list( fact_list pars, fact_list conds, 
			      fact_list goals, int quant )
{
  effect_list result;
  
  result = ( effect_list ) calloc( 1, sizeof( effect_list_elt ) );
  result->quantified_variables = ( fact_list ) calloc( 1, sizeof( fact_list_elt ) );
  result->quantified_variables->item = 
    ( token_list ) calloc( 1, sizeof( token_list_elt ) );
  result->quantified_variables->item->item = ( token ) calloc( 1, sizeof( char ) );
  result->quantified_variables->item->item[0] = QUANTIFIERS[quant];
  result->quantified_variables->next = pars;
  result->conditions = conds;
  result->add_effects = goals;
  result->del_effects = NULL;
  result->next = NULL;
  return result;
}


void print_factlist( fact_list list )
{

  fact_list i_list;
  token_list i_token;

  for ( i_list = list; i_list; i_list = i_list->next ) 
    for ( i_token = i_list->item; i_token; i_token = i_token->next )
      printf( "%s ", i_token->item );
}

/* prints out facts */
void print_fct( fact_list con_list, token_list ini_list, token_list gol_list )

{

  printf( "\nconstants: " );
  print_factlist( con_list ); 

  printf( "\n\ninitial: " );
  print_tokenlist( ini_list );

  printf( "\n\ngoal: " );
  print_tokenlist( gol_list );

  printf( "\n" );

}

  
void print_tokenlist(token_list list)
{
  token_list i_token;

  for ( i_token = list; i_token; i_token = i_token->next )
    {
      printf( "\n%s ", i_token->item );
      if (!strcmp(i_token->item, ""))
	printf("Match\n");
    }
}
